<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroup ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroup extends AbstractStructArrayBase
{
    /**
     * The FareGroup
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroup[]
     */
    public $FareGroup;
    /**
     * Constructor method for ArrayOfJP_FareGroup
     * @uses ArrayOfJP_FareGroup::setFareGroup()
     * @param \StructType\JP_FareGroup[] $fareGroup
     */
    public function __construct(array $fareGroup = array())
    {
        $this
            ->setFareGroup($fareGroup);
    }
    /**
     * Get FareGroup value
     * @return \StructType\JP_FareGroup[]|null
     */
    public function getFareGroup()
    {
        return $this->FareGroup;
    }
    /**
     * This method is responsible for validating the values passed to the setFareGroup method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareGroup method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareGroupForArrayConstraintsFromSetFareGroup(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FareGroupFareGroupItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupFareGroupItem instanceof \StructType\JP_FareGroup) {
                $invalidValues[] = is_object($arrayOfJP_FareGroupFareGroupItem) ? get_class($arrayOfJP_FareGroupFareGroupItem) : sprintf('%s(%s)', gettype($arrayOfJP_FareGroupFareGroupItem), var_export($arrayOfJP_FareGroupFareGroupItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareGroup property can only contain items of type \StructType\JP_FareGroup, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroup[] $fareGroup
     * @return \ArrayType\ArrayOfJP_FareGroup
     */
    public function setFareGroup(array $fareGroup = array())
    {
        // validation for constraint: array
        if ('' !== ($fareGroupArrayErrorMessage = self::validateFareGroupForArrayConstraintsFromSetFareGroup($fareGroup))) {
            throw new \InvalidArgumentException($fareGroupArrayErrorMessage, __LINE__);
        }
        $this->FareGroup = $fareGroup;
        return $this;
    }
    /**
     * Add item to FareGroup value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroup $item
     * @return \ArrayType\ArrayOfJP_FareGroup
     */
    public function addToFareGroup(\StructType\JP_FareGroup $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroup) {
            throw new \InvalidArgumentException(sprintf('The FareGroup property can only contain items of type \StructType\JP_FareGroup, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareGroup[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroup|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroup|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroup|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroup|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroup|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroup
     */
    public function getAttributeName()
    {
        return 'FareGroup';
    }
}
